/*
 *  TOPPERS/SSP Kernel
 *      Smallest Set Profile Kernel
 * 
 *  Copyright (C) 2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2010 by Meika Sugimoto
 *  Copyright (C) 2013 by Naoki Saito
 *             Nagoya Municipal Industrial Research Institute, JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 */

/*
 *  ץå¸⥸塼 ֥ARM-Mѡ
 */

#define TOPPERS_MACRO_ONLY
#define UINT_C(val)		(val)		/* uint_tޥ */
#define ULONG_C(val)	(val)		/* ulong_tޥ */
#define CAST(type, val)	(val)		/* 㥹ȤԤޥ */

#include "kernel_impl.h"
#include "arm_m.h"


	.text

/*
 *  
 */
	.global		intnest

/*
 *  CPU㳰ȥ
 *
 *  ߥȥȽƤƱμबۤʤ뤿ᡤ
 *  ʬƤ롥
 */
	.align 2
	.syntax unified
	.code 16
	.global exc_entry
	.type exc_entry, function
	/*
	 *  㳰/ߤȯȡå(MSP)˥å쥸¸롥
	 *  Ƥ˲äơCPU㳰ϥɥؤξȤơ
	 *  EXC_RETURNξ¸롥
	 *
	 *   ----------- <----- p_excinf
	 *  | EXC_RETURN|  
	 *   -----------
	 *  |    R0     |  
	 *   -----------
	 *  |    R1     |
	 *   -----------
	 *  |    R2     |
	 *   -----------
	 *  |    R3     |
	 *   -----------
	 *  |    R12    |
	 *   -----------
	 *  |    LR     |
	 *   -----------
	 *  |    PC     |
	 *   -----------
	 *  |   xPSR    |
	 *   -----------
	 *
	 */
exc_entry:
	cpsid i     	/* ߶ػ */
	push  {lr}  	/* EXC_RETURN Ѥ			  */
	mov   r0, sp	/* CPU㳰ϥɥؤΰȤʤ */
	
	/* ߥͥȿβû */
	ldr r1 , =intnest
	ldr r3 , [r1]
	adds r3 , #1
	str r3 , [r1]

	/*
	 *  ̽
	 */
exc_entry_2:
	/* ϥɥ饢ɥ쥹 */
	mrs   r2, ipsr   	// r2: 㳰ֹ
	ldr   r1, =_kernel_exc_tbl
	lsls  r3, r2 , #2	// r3 = r2 * 4  (r3:ơ֥ƬΥեå)
	adds  r3, r3, r1	// r3 = r3 + r1 (r3:ǤγǼɥ쥹)
	ldr   r1, [r3]  	// r1:ϥɥ鵯ưɥ쥹
	
#ifdef LOG_EXC_ENTER
	push  {r0, r2, r3}
	mov   r0, r2            /* 㳰ֹѥ᡼  */
	bl    log_exc_enter     /* log_exc_enterƤӽФ */
	pop   {r0, r2, r3}  	// r0:SP, r2:ֹ
#endif /* LOG_EXC_ENTER */

#ifdef LOG_EXC_LEAVE
	push  { r2 }            /* 㳰ֹ򥹥å    */
#endif /* LOG_EXC_LEAVE */

	/*
	 *  CPU㳰ϥɥθƤӽФ
	 */
	cpsie i                 /* å */
	blx   r1
	cpsid i                 /* å */

#ifdef LOG_EXC_LEAVE
	pop   { r0 }                 /* 㳰ֹ        */
	bl    log_exc_leave          /* log_exc_leaveƤӽФ */
#endif /* LOG_EXC_LEAVE */
	
	b     ret_exc


/*
 *  ߥȥ
 */
	.align 2
	.syntax unified
	.code 16
	.global int_entry
	.type int_entry, function
int_entry:
	cpsid i     	/* ߶ػ */
	push  {lr}  	/* EXC_RETURN Ѥ */
	mov   r0, sp	/* ̤γߤȯξȤ */
	
	/*
	 *	̽
	 */
int_entry_2:
	/* ߥͥȿβû */
	ldr r1 , =intnest
	ldr r3 , [r1]
	adds r3 , #1
	str r3 , [r1]
	
	/* ϥɥ饢ɥ쥹 */
	mrs   r2, ipsr   	// r2: ֹ
	ldr   r1, =_kernel_exc_tbl
	lsls  r3, r2 , #2	// r3 = r2 * 4  (r3:ơ֥ƬΥեå)
	adds  r3, r3, r1	// r3 = r3 + r1 (r3:ǤγǼɥ쥹)
	ldr   r1, [r3]  	// r1:ϥɥ鵯ưɥ쥹

#ifdef LOG_INH_ENTER
	push  {r0,r2,r3}
	mov   r0, r2        	/* ֹѥ᡼  */
	bl    log_inh_enter 	/* log_inh_enterƤӽФ */
	pop   { r0,r2,r3 }  	/* r0:SP, r2:ֹ */
#endif /* LOG_INH_ENTER */

#ifdef LOG_INH_LEAVE
	push  { r2 }        	/* ֹ򥹥å    */
#endif /* LOG_INH_LEAVE */

	/*
	 *  ߥϥɥθƤӽФ
	 */
	cpsie i                 /* å */
	blx   r1
	cpsid i                 /* å */
	
#ifdef LOG_INH_LEAVE
	pop   { r0 }                   /* ֹ        */
	bl    log_inh_leave          /* log_inh_leaveƤӽФ */
#endif /* LOG_INH_LEAVE */

/*
 *  /㳰и
 *
 *  ret_exc/ret_intϡCPU㳰/ߥϥɥ餫äľ˼¹Ԥ
 *  롼Ǥ롥
 */
ret_exc:
ret_int:
	/*
	 *  ǳߥå֤Ȥ뤬ǤPRIMASK.PM򥻥åȤƤ
	 *  ̤˹ԤȤϤʤ
	 */
	/*
	 *  ΥƥȤȽ
	 * 
	 *  intnest0ɤȽǤ
	 *  
	 */
	/* ߥͥȿθ */
	ldr r1 , =intnest
	ldr r3 , [r1]
	adds r3 , #-1
	str r3 , [r1]
	
	cmp   r3 , #0
	beq   ret_int_2

	/*
	 * ߽и(ǥѥåʤ)
	 *
	 * ñˡȯ
	 */
ret_int_1:
	/*
	 *  CPUå֡PRIMASKåȤ줿֡ˡHandler⡼ɤǤ롥
	 *  Thread⡼ɤؤΥ꥿ˤPRIMASKξ֤Ѳʤ
	 *  ꥿˲롥
	 */ 
	pop		{ r2 }	/* EXC_RETURN --> r2 */
	cpsie	i
	bx	  r2      	/* (or 㳰)ȯ꥿ */
	
	/*
	 * ƥȤγߤξ
	 */
ret_int_2:
	ldr   r0, =reqflg             /* reqflgfalseʤ餽Τޤ */
	ldr   r1, [r0]
	cmp   r1 , #0
	beq    ret_int_1           /* falseʤret_int_1(Τޤޥ꥿) */

	/*
	 * ǥѥå
	 */
ret_int_3:
	movs   r1, #0                   /* reqflgfalse */
	str   r1, [r0]
	
	/*
	 *  Thread⡼ɤذܹԤ롥
	 *
	 *  search_schedtsk  run_taskƤӽФϡ
	 *  Thread⡼ɡCPUå֤Ǥɬפ롥
	 *  CPUå֤ˤĤƤϴCPUåΤᡤä˹ԤȤϤʤ
	 *
	 *  Thread⡼ɤؤΰܹԤˤ(MSP)å˥ߡ㳰ե졼֤ơ
	 *  Ū˳ߥϥɥ餫꥿󤹤롥
	 */
	pop 	{r2}            	  /* EXC_RETURN --> r2 */
	ldr   r0, =ret_int_4		  /* PC   */
	ldr   r1, =EPSR_T			  /* xPSR(TӥåȤ'1'Ǥɬפ) */
	stm sp!, {r0-r1}			  /* ߡե졼򥹥åѤ	*/
	sub   sp, #(EXC_FRAME_SIZE - (4*2)) /* r0-r3,r12,lrƤꤹɬפʤ */
	cpsie	i
	bx	  r2					  /* Thread⡼ɤذܹ */

	/*
	 *  Thread ⡼ɤư
	 * ȯpush줿쥸Ƥƥ꥿󤹤
	 */
ret_int_4:
	bl    search_schedtsk		/* ǵư줿¹ */
	bl    run_task
ret_int_r:
	ldr 	r0, [sp, #(EXC_FRAME_SIZE-(4*4))]	// R12
	mov 	r12, r0
	ldr 	r0, [sp, #(EXC_FRAME_SIZE-(4*3))]	// LR
	mov 	lr, r0
	ldr 	r0, [sp, #(EXC_FRAME_SIZE-(4*2))]	// PC
	movs 	r1, #1    	// ե饰˱ƶΤǡxpsr᤹˽
	orrs 	r0, r0, r1	// bit01ˤ(ARMv6-MϾThumb¹Ծ֤ư)
	ldr 	r2, [sp, #(EXC_FRAME_SIZE-(4*1))]	// xPSR
	msr 	xpsr_nzcvq, r2
	str 	r0, [sp, #(EXC_FRAME_SIZE-(4*1))]	// xPSRΰ֤PC֤ͤ
	ldmfd 	sp!, {r0-r3}
	add 	sp, sp, #(4*3)  	// sp += (4*3)
	cpsie	i
	pop 	{pc}	// ꥿

/*
 *  SVCϥɥ(פʤΤǡͽ)
 */
	.align	2
	.thumb
	.thumb_func
	.globl kernel_svc_handler
	.type kernel_svc_handler, function
kernel_svc_handler:
	cpsie i					/* CPUå֤ */
	bx		lr				/* ꥿	  */

/*
 *  ǥѥåư
 */
	.align	2
	.thumb
	.thumb_func
	.globl start_dispatch
	.type start_dispatch, function
start_dispatch:
	/*
	 *  Υ롼ϡͥ뵯ưˡ٤Ƥγߤػߤ
	 * ʳߥå֤ƱˤǸƤӽФ롥
	 *  ޤThread⡼ɤǸƤӽФ뤳ȤꤷƤ롥
	 *
	 *  Ǥϡƥξ֤CPUå֡ͥ٥ޥ֡
	 *  ǥѥåľ֤˰ܹԤåݥ󥿤
	 *  dispatcher(task.c) إפ롥
	 *
	 *  CPUå֤ȳߥå֤϶PRIMASK椹褦Ƥ뤿
	 *  Ǥ˥ƥCPUå֤ˤʤäƤ롥
	 *  ͥ٥ޥˤĤƤϡƥ൯ưˤ(ץå)¹ͥ٤
	 *  ٥ͥ٤Ǥ뤿ᡤ(߽ǥ)ͥ٥ޥ֤
	 *  Ʊξ֤ˤʤäƤ롥
	 *  ˡtask_initializedisdspfalse˽Ƥ뤿ᡤ
	 *  ǥѥåľ֤ˤʤäƤ롥
	 */
	ldr   r0,=istkpt              /* MSP   */
	ldr   r1,[r0]                 /* start_dispatchƤӽФ˸ƤӽФѤ */
	msr   msp, r1                 /* ѤƤ뤿             */
	b	  dispatcher

/*
 *  ͥνλθƽФ
 *
 *  å
 *  
 */
	.text
	.syntax unified
	.code 16
	.globl call_exit_kernel
	.type call_exit_kernel, function
call_exit_kernel:
	ldr   r0,=istkpt              /* MSP   */
	ldr   r1,[r0]                 /* start_dispatchƤӽФ˸ƤӽФѤ */
	msr   msp, r1                 /* ѤƤ뤿             */
	b     exit_kernel       /* ͥνλƤ */


/*
 *  Ԥ( SIL_DLY_TIMx ˤĤƤ̤)
 */
	.text
	.syntax unified
	.code 16
	.globl sil_dly_nse
	.type sil_dly_nse, function
sil_dly_nse:
	subs   r0, r0, #SIL_DLY_TIM1
	cmp   r0, #0
	bgt   sil_dly_nse1
	mov   pc, lr
sil_dly_nse1:
	subs   r0, r0, #SIL_DLY_TIM2
	cmp   r0, #0
	bgt   sil_dly_nse1
	mov   pc, lr
